# ImageBase

[![Build Status](https://github.com/JuliaImages/ImageBase.jl/workflows/CI/badge.svg)](https://github.com/JuliaImages/ImageBase.jl/actions)
[![Coverage](https://codecov.io/gh/JuliaImages/ImageBase.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaImages/ImageBase.jl)
[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]

This is a twin package to [ImageCore] with functions that are used among many of the packages in JuliaImages.
The main purpose of this package is to reduce unnecessary compilation overhead from external dependencies.

This package reexports [ImageCore] so can be a direct replacement of it.

Check the [reference page](https://juliaimages.org/ImageCore.jl/stable/reference) for more information of the functions.


[ImageCore]: https://github.com/JuliaImages/ImageCore.jl
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaImages.github.io/ImageBase.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://JuliaImages.github.io/ImageBase.jl/dev

module ImageBase

export
    # two-fold downsampling
    # originally from ImageTransformations.jl
    restrict,

    # basic image statistics, from Images.jl
    minimum_finite,
    maximum_finite,
    meanfinite,
    varfinite,
    sumfinite

using Reexport

using Base.Cartesian: @nloops
@reexport using ImageCore
using ImageCore.OffsetArrays

include("diff.jl")
include("restrict.jl")
include("utils.jl")
include("statistics.jl")
include("deprecated.jl")

if VERSION >= v"1.4.2" # work around https://github.com/JuliaLang/julia/issues/34121
    include("precompile.jl")
    _precompile_()
end

end

@testset "deprecation" begin
    @testset "restrict" begin
        A = rand(N0f8, 4, 5, 3)
        @test restrict(A, [1, 2]) == restrict(A, (1, 2))
    end

    @testset "statistics" begin
        A = rand(Float32, 4, 4) .- 0.5
        @test minfinite(A, dims=1) == minimum_finite(A, dims=1)
        @test minfinite(A) == minimum_finite(A)
        @test maxfinite(A, dims=1) == maximum_finite(A, dims=1)
        @test maxfinite(A) == maximum_finite(A)

        @test maxabsfinite(A) == maximum_finite(abs, A)
        @test maxabsfinite(A, dims=1) == maximum_finite(abs, A, dims=1)
    end

    @testset "fdiff entrypoints" begin
        A = rand(Float32, 5)
        @test ImageBase.fdiff(A, rev=true) == ImageBase.FiniteDiff.fdiff(A, rev=true)
        out = similar(A)
        @test ImageBase.fdiff!(out, A, rev=false) == ImageBase.FiniteDiff.fdiff!(out, A, rev=false)
    end
end

# AbstractGray and Color3 tests should be generated seperately
function generate_test_types(number_types::AbstractArray{<:DataType}, color_types::AbstractArray{<:UnionAll})
    test_types = map(Iterators.product(number_types, color_types)) do T
        try
            T[2]{T[1]}
        catch err
            !isa(err, TypeError) && rethrow(err)
        end
    end
    test_types = filter(x->x != false, test_types)
    if isempty(filter(x->x<:Color3, test_types))
        test_types = [number_types..., test_types...]
    end
    test_types
end

using ImageBase
using ImageBase: varmult
using Statistics
using Test

@testset "Reductions" begin
    _abs(x::Colorant) = mapreducec(abs, +, 0, x)

    @testset "sumfinite, meanfinite, varfinite" begin
        for T in generate_test_types([N0f8, Float32], [Gray, RGB])
            A = rand(T, 5, 5)
            s12 = sum(A, dims=(1,2))
            @test eltype(s12) <: Union{T, float(T), float64(T)}

            @test sumfinite(A) ≈ sum(A)
            @test sumfinite(A, dims=1) ≈ sum(A, dims=1)
            @test sumfinite(A, dims=(1, 2)) ≈ sum(A, dims=(1, 2))

            @test meanfinite(A) ≈ mean(A)
            @test meanfinite(A, dims=1) ≈ mean(A, dims=1)
            @test meanfinite(A, dims=(1, 2)) ≈ mean(A, dims=(1, 2))

            @test varfinite(A) ≈ varmult(⋅, A)
            @test varfinite(A, dims=1) ≈ varmult(⋅, A, dims=1)
            @test varfinite(A, dims=(1, 2)) ≈ varmult(⋅, A, dims=(1, 2))

            # test NaN/Inf
            if eltype(T) != N0f8
                A = rand(T, 5, 5) .- 0.5 .* oneunit(T)
                A[1] = Inf
                @test sum(A) ≈ A[1]
                @test sum(abs, A) ≈ A[1]
                @test sumfinite(A) ≈ sum(A[2:end])
                @test sumfinite(abs, A) ≈ sum(abs, A[2:end])
                A[1] = NaN
                @test isnan(sum(A))
                @test isnan(sum(abs, A))
                @test sumfinite(A) ≈ sum(A[2:end])
                @test sumfinite(abs, A) ≈ sum(abs, A[2:end])

                A = rand(T, 5, 5) .- 0.5 .* oneunit(T)
                A[1] = Inf
                @test mean(A) ≈ A[1]
                @test mean(abs, A) ≈ A[1]
                @test meanfinite(A) ≈ mean(A[2:end])
                @test meanfinite(abs, A) ≈ mean(abs, A[2:end])
                A[1] = NaN
                @test isnan(mean(A))
                @test isnan(mean(abs, A))
                @test meanfinite(A) ≈ mean(A[2:end])
                @test meanfinite(abs, A) ≈ mean(abs, A[2:end])

                A = rand(T, 5, 5)
                A[1] = Inf
                @test isnan(varmult(⋅, A))
                @test varfinite(A) ≈ varmult(⋅, A[2:end])
                A[1] = NaN
                @test isnan(varmult(⋅, A))
                @test varfinite(A) ≈ varmult(⋅, A[2:end])
            end
        end

        A = [NaN, 1, 2, 3]
        @test meanfinite(A, dims=1) ≈ [2]
        @test varfinite(A, dims=1) ≈ [1]

        A = [NaN NaN 1;
            1 2 3]
        vf = varfinite(A, dims=2)
        @test isnan(vf[1])

        A = [NaN 1 2 3;
            NaN 6 5 4]
        mf = meanfinite(A, dims=1)
        vf = varfinite(A, dims=1)
        @test isnan(mf[1])
        @test mf[2:end] ≈ [3.5,3.5,3.5]
        @test isnan(vf[1])
        @test vf[2:end] ≈ [12.5,4.5,0.5]

        @test meanfinite(A, dims=2) ≈ reshape([2, 5], 2, 1)
        @test varfinite(A, dims=2) ≈ reshape([1, 1], 2, 1)

        @test meanfinite(A, dims=(1,2)) ≈ [3.5]
        @test varfinite(A, dims=(1,2)) ≈ [3.5]

        # Ensure we're consistant with our decision to `abs2` in ColorVectorSpace
        # See also: https://github.com/JuliaGraphics/ColorVectorSpace.jl/blob/master/README.md#abs-and-abs2
        A = rand(Gray, 4, 4)
        @test varfinite(A) ≈ varfinite(RGB.(A))
        A[1] = Inf
        @test varfinite(A) ≈ varfinite(RGB.(A))
        A[1] = NaN
        @test varfinite(A) ≈ varfinite(RGB.(A))
    end

    @testset "minfinite, maxfinite, maxabsfinite" begin
        for T in generate_test_types([N0f8, Float32], [Gray, ])
            A = rand(T, 5, 5)
            @test @inferred(minimum_finite(A)) == minimum(A)
            @test @inferred(maximum_finite(A)) == maximum(A)
            @test minimum_finite(A; dims=1) == minimum(A; dims=1)
            @test maximum_finite(A; dims=1) == maximum(A; dims=1)
            @test_broken @inferred maximum_finite(A; dims=1)
            @test_broken @inferred minimum_finite(A; dims=1)

            @test maximum_finite(abs2, A) == maximum(abs2, A)
            @test_broken @inferred maximum(abs2, A)
            @test_broken @inferred minimum(abs2, A)

            if eltype(T) != N0f8
                A = rand(T, 5, 5) .- 0.5 * rand(T, 5, 5)
                A[1] = Inf

                @test @inferred(minimum_finite(A)) == minimum(A[2:end])
                @test @inferred(maximum_finite(A)) == maximum(A[2:end])
                @test minimum_finite(abs, A) == minimum(abs, A[2:end])
                @test maximum_finite(abs2, A) == maximum(abs2, A[2:end])
            end
        end

        # minimum_finite and maximum_finite for RGB are processed per channel
        A = rand(RGB{Float32}, 5, 5)
        @test minimum_finite(A) == RGB(minimum(channelview(A), dims=(2, 3))...)
        @test maximum_finite(A) == RGB(maximum(channelview(A), dims=(2, 3))...)

        # Container of abstract type
        A = Any[1, 2, Gray(0.3)]
        @test minimum_finite(A) == 0.3
        @test maximum_finite(A) == 2.0
        @test Base.return_types(minimum_finite, (typeof(A),)) == Base.return_types(minimum, (typeof(A), ))
    end

end

using ImageBase, OffsetArrays, StackViews
using ImageFiltering
using Test, TestImages, Aqua, Documenter

using OffsetArrays: IdentityUnitRange
include("testutils.jl")

@testset "ImageBase.jl" begin
    @testset "Project meta quality checks" begin
        if Base.VERSION >= v"1.3"
            # Not checking compat section for test-only dependencies
            Aqua.test_ambiguities(ImageBase)
            Aqua.test_all(ImageBase;
                ambiguities=false,
                project_extras=true,
                deps_compat=true,
                stale_deps=true,
                project_toml_formatting=true
            )
            doctest(ImageBase, manual = false)
        end
    end

    include("diff.jl")
    include("restrict.jl")
    include("statistics.jl")

    if Base.JLOptions().depwarn != 2
        @info "deprecations are expected"
        include("deprecated.jl")
    end
end

"""
    restrict(img[, dims]) -> imgr

Reduce the size of `img` by approximately two-fold along the dimensions listed in
`dims`, or all spatial coordinates if `dims` is not specified.

# Output

The type of output array `imgr` depends on the input type:

- If `img` is an `OffsetArray`, then output array `imgr` will also be an `OffsetArray`.
- If `img` is not an `OffsetArray`, then output array `imgr` will be an `Array` type
  even if it has offset indices.

The size of `imgr` is approximately `1/2` of the original size. More specifically:

- if `Nₖ = size(img, k)` is odd, then `size(imgr, k) == (Nₖ+1) ÷ 2`.
- if `Nₖ = size(img, k)` is even, then `size(imgr, k) == (Nₖ÷2) + 1`.

# Examples

The optional argument `dims` can be a `Tuple` or `Integer`:

```julia
A = rand(5, 5) # size: (5, 5)

restrict(A) # size: (3, 3)

restrict(A, 1) # size: (3, 5)
restrict(A, 2) # size: (5, 3)

restrict(A, (1, )) # size: (3, 5)
restrict(A, (1, 2)) # size: (3, 3)
```

Unless the input array is 1-based, the origin will be halfed:

```julia
julia> using ImageBase, OffsetArrays

julia> Ao = OffsetArray(rand(5, 4), 5, 6);

julia> Ar = restrict(Ao);

julia> axes(Ao)
(OffsetArrays.IdOffsetRange(values=6:10, indices=6:10), OffsetArrays.IdOffsetRange(values=7:10, indices=7:10))

julia> axes(Ar)
(OffsetArrays.IdOffsetRange(values=3:5, indices=3:5), OffsetArrays.IdOffsetRange(values=4:6, indices=4:6))
```

# Extended help

The term `restrict` is taken from the coarsening operation of algebraic multigrid
methods; it is the adjoint of "prolongation" (which is essentially interpolation).
`restrict` anti-aliases the image as it goes, so is better than a naive summation
over 2x2 blocks.
The implementation of `restrict` has been tuned for performance, and should be
a fast method for constructing [pyramids](https://en.wikipedia.org/wiki/Pyramid_(image_processing)).

If `l` is the size of `img` along a particular dimension, `restrict` produces an
array of size `(l+1)÷2` for odd `l`,
and `l÷2 + 1` for even `l`. See the example below for an explanation.

See also `ImageTransformations.imresize`.

# Example

```julia
a_coarse = [0, 1, 0.3]
```
If we were to interpolate this at the halfway points, we'd get
```julia
a_fine = [0, 0.5, 1, 0.65, 0.3]
```
Note that `a_fine` is obtained from `a_coarse` via the *prolongation* operator `P` as
`P*a_coarse`, where
```julia
P = [1   0   0;      # this line "copies over" the first point
     0.5 0.5 0;      # this line takes the mean of the first and second point
     0   1   0;      # copy the second point
     0   0.5 0.5;    # take the mean of the second and third
     0   0   1]      # copy the third
```
`restrict` is the adjoint of prolongation. Consequently,
```julia
julia> restrict(a_fine)
3-element Array{Float64,1}:
 0.125
 0.7875
 0.3125

julia> (P'*a_fine)/2
3-element Array{Float64,1}:
 0.125
 0.7875
 0.3125
```
where the division by 2 approximately preserves the mean intensity of the input.

As we see here, for odd-length `a_fine`, restriction is the adjoint of interpolation at half-grid points.
When `length(a_fine)` is even, restriction is the adjoint of interpolation at 1/4 and 3/4-grid points.
This turns out to be the origin of the `l->l÷2 + 1` behavior.

One consequence of this definition is that the edges move towards zero:
```julia
julia> restrict(ones(11))
6-element Array{Float64,1}:
 0.75
 1.0
 1.0
 1.0
 1.0
 0.75
```
In some applications (e.g., image registration), you may find it useful to trim the edges.
"""
restrict(img::AbstractArray, ::Tuple{}) = img

restrict(A::AbstractArray) = restrict(A, coords_spatial(A))
function restrict(A::AbstractArray, dims::Dims)
    restrict(restrict(A, dims[1]), Base.tail(dims))
end

function restrict(A::AbstractArray{T,N}, dim::Integer) where {T,N}
    if Base.has_offset_axes(A)
        # For type stability, we cannot return `OffsetArray` in this method
        A = OffsetArrays.no_offset_view(A)
    end

    indsA = axes(A)
    newinds = ntuple(i->i==dim ? restrict_indices(indsA[dim]) : indsA[i], Val(N))
    out = Array{restrict_eltype(first(A)), N}(undef, last.(newinds))
    restrict!(out, A, dim)
    out
end
function restrict(A::OffsetArray{T,N}, dim::Integer) where {T,N}
    indsA = axes(A)
    newinds = map(UnitRange, ntuple(i->i==dim ? restrict_indices(indsA[dim]) : indsA[i], Val(N)))
    # By shifting it back to normal array, the internal for loop becomes faster because
    # it requires less indexing computation
    OffsetArray(restrict(A.parent, dim), newinds)
end

function restrict_eltype(A::AbstractArray)
    # infer the restrict_eltype on `eltype(A)` while preserving the container type
    # TODO: maybe there's more efficient way than the `similar` here..
    typeof(similar(A, _restrict_eltype(eltype(A)), ntuple(_->1, ndims(A))))
end
restrict_eltype(x) = _restrict_eltype(typeof(x))

for CT in (:AbstractGray, :AbstractRGB, :TransparentGray, :TransparentRGB)
    @eval _restrict_eltype(::Type{C}) where C<:$CT = __restrict_eltype(C)
end
_restrict_eltype(::Type{T}) where T = typeof(one(T)/4 + one(T)/2)
_restrict_eltype(::Type{C}) where C<:Color = __restrict_eltype(RGB{eltype(C)})
_restrict_eltype(::Type{C}) where C<:Colorant = __restrict_eltype(ARGB{eltype(C)})
function __restrict_eltype(::Type{C}) where C
    BT = base_colorant_type(C)
    isconcretetype(BT) && return floattype(BT)
    BT{_restrict_eltype(eltype(C))}
end

function restrict!(out::AbstractArray{T,N}, A::AbstractArray, dim) where {T,N}
    # a no-op for singleton dimension
    if size(A, dim) == 1 # this includes `dim > N` cases
        return copyto!(out, A)
    end
    indsout, indsA = axes(out), axes(A)
    ndims(out) == ndims(A) || throw(DimensionMismatch("input and output must have the same number of dimensions"))
    for d = 1:length(indsA)
        target = d==dim ? restrict_indices(indsA[d]) : indsA[d]
        indsout[d] == target || error("input and output must have corresponding indices; to be consistent with the input indices,\ndimension $d should be $target, got $(indsout[d])")
    end
    indspre, indspost = indsA[1:dim-1], indsA[dim+1:end]
    _restrict!(out, indsout[dim], A, indspre, indsA[dim], indspost)
end

@generated function _restrict!(out, indout, A,
                               indspre::NTuple{Npre,AbstractUnitRange},
                               indA,
                               indspost::NTuple{Npost,AbstractUnitRange}) where {Npre,Npost}
    Ipre = [Symbol(:ipre_, d) for d = 1:Npre]
    Ipost = [Symbol(:ipost_, d) for d = 1:Npost]
    quote
        $(Expr(:meta, :noinline))
        T = eltype(out)
        if isodd(length(indA))
            half = convert(eltype(T), 0.5)
            quarter = convert(eltype(T), 0.25)
            @nloops $Npost ipost d->indspost[d] begin
                iout = first(indout)
                @nloops $Npre ipre d->indspre[d] begin
                    out[$(Ipre...), iout, $(Ipost...)] = zero(T)
                end
                ispeak = true
                for iA in indA
                    if ispeak
                        @inbounds @nloops $Npre ipre d->indspre[d] begin
                            out[$(Ipre...), iout, $(Ipost...)] +=
                                half*convert(T, A[$(Ipre...), iA, $(Ipost...)])
                        end
                    else
                        @inbounds @nloops $Npre ipre d->indspre[d] begin
                            tmp = quarter*convert(T, A[$(Ipre...), iA, $(Ipost...)])
                            out[$(Ipre...), iout, $(Ipost...)]   += tmp
                            out[$(Ipre...), iout+1, $(Ipost...)] = tmp
                        end
                    end
                    ispeak = !ispeak
                    iout += ispeak
                end
            end
        else
            threeeighths = convert(eltype(T), 0.375)
            oneeighth = convert(eltype(T), 0.125)
            z = zero(T)
            fill!(out, zero(T))
            @nloops $Npost ipost d->indspost[d] begin
                peakfirst = true
                iout = first(indout)
                for iA in indA
                    if peakfirst
                        @inbounds @nloops $Npre ipre d->indspre[d] begin
                            tmp = convert(T, A[$(Ipre...), iA, $(Ipost...)])
                            out[$(Ipre...), iout, $(Ipost...)] += threeeighths*tmp
                            out[$(Ipre...), iout+1, $(Ipost...)] += oneeighth*tmp
                        end
                    else
                        @inbounds @nloops $Npre ipre d->indspre[d] begin
                            tmp = convert(T, A[$(Ipre...), iA, $(Ipost...)])
                            out[$(Ipre...), iout, $(Ipost...)]   += oneeighth*tmp
                            out[$(Ipre...), iout+1, $(Ipost...)] += threeeighths*tmp
                        end
                    end
                    peakfirst = !peakfirst
                    iout += peakfirst
                end
            end
        end
        out
    end
end

# If we're restricting along dimension 1, there are some additional efficiencies possible
@generated function _restrict!(out, indout, A, ::NTuple{0,AbstractUnitRange},
                               indA, indspost::NTuple{Npost,AbstractUnitRange}) where Npost
    Ipost = [Symbol(:ipost_, d) for d = 1:Npost]
    quote
        $(Expr(:meta, :noinline))
        T = eltype(out)
        if isodd(length(indA))
            half = convert(eltype(T), 0.5)
            quarter = convert(eltype(T), 0.25)
            @inbounds @nloops $Npost ipost d->indspost[d] begin
                iout, iA = first(indout), first(indA)
                nxt = convert(T, A[iA+1, $(Ipost...)])
                out[iout, $(Ipost...)] = half*convert(T, A[iA, $(Ipost...)]) + quarter*nxt
                for iA in first(indA)+2:2:last(indA)-2
                    prv = nxt
                    nxt = convert(T, A[iA+1, $(Ipost...)])
                    out[iout+=1, $(Ipost...)] = quarter*(prv+nxt) + half*convert(T, A[iA, $(Ipost...)])
                end
                out[iout+1, $(Ipost...)] = quarter*nxt + half*convert(T, A[last(indA), $(Ipost...)])
            end
        else
            threeeighths = convert(eltype(T), 0.375)
            oneeighth = convert(eltype(T), 0.125)
            z = zero(T)
            @inbounds @nloops $Npost ipost d->indspost[d] begin
                c = d = z
                iA = first(indA)
                for iout = first(indout):last(indout)-1
                    a, b = c, d
                    c, d = convert(T, A[iA, $(Ipost...)]), convert(T, A[iA+1, $(Ipost...)])
                    iA += 2
                    out[iout, $(Ipost...)] = oneeighth*(a+d) + threeeighths*(b+c)
                end
                out[last(indout), $(Ipost...)] = oneeighth*c + threeeighths*d
            end
        end
        out
    end
end

restrict_size(len::Integer) = isodd(len) ? (len+1)>>1 : (len>>1)+1
function restrict_indices(r::AbstractUnitRange)
    f, l = first(r), last(r)
    isodd(f) && return (f+1)>>1:restrict_size(l)
    f>>1 : (isodd(l) ? (l+1)>>1 : l>>1)
end
restrict_indices(r::Base.OneTo) = Base.OneTo(restrict_size(length(r)))
function restrict_indices(r::UnitRange)
    f, l = first(r), last(r)
    isodd(f) && return (f+1)>>1:restrict_size(l)
    f>>1 : (isodd(l) ? (l+1)>>1 : l>>1)
end

using ImageBase.FiniteDiff
# TODO(johnnychen94): remove this after we delete `Imagebase.fdiff` and `ImageBase.fdiff!` entrypoints
using ImageBase.FiniteDiff: fdiff, fdiff!

@testset "fdiff" begin
    # Base.diff doesn't promote integer to float
    @test ImageBase.FiniteDiff.maybe_floattype(Int) == Int
    @test ImageBase.FiniteDiff.maybe_floattype(N0f8) == Float32
    @test ImageBase.FiniteDiff.maybe_floattype(RGB{N0f8}) == RGB{Float32}

    @testset "API" begin
        # fdiff! works the same as fdiff
        mat_in = rand(3, 3, 3)
        mat_out = similar(mat_in)
        fdiff!(mat_out, mat_in, dims = 2)
        @test mat_out == fdiff(mat_in, dims = 2)

        mat_in = rand(3, 3, 3)
        mat_out = similar(mat_in)
        fdiff!(mat_out, mat_in, dims = 3, rev=true)
        @test mat_out == fdiff(mat_in, dims = 3, rev=true)

        # default `dims` are only available when input is a vector
        v = rand(9)
        @test fdiff(v) == fdiff(v; dims=1)
        m = rand(3, 3)
        @test_throws UndefKeywordError fdiff(m)
    end

    @testset "NumericalTests" begin
        a = reshape(collect(1:9), 3, 3)
        b_fd_1 = [1 1 1; 1 1 1; -2 -2 -2]
        b_fd_2 = [3 3 -6; 3 3 -6; 3 3 -6]
        b_bd_1 = [-2 -2 -2; 1 1 1; 1 1 1]
        b_bd_2 = [-6 3 3; -6 3 3; -6 3 3]
        out = similar(a)

        @test fdiff(a, dims = 1) == b_fd_1
        @test fdiff(a, dims = 2) == b_fd_2
        @test fdiff(a, dims = 1, rev=true) == b_bd_1
        @test fdiff(a, dims = 2, rev=true) == b_bd_2
        fdiff!(out, a, dims = 1)
        @test out == b_fd_1
        fdiff!(out, a, dims = 2)
        @test out == b_fd_2
        fdiff!(out, a, dims = 1, rev=true)
        @test out == b_bd_1
        fdiff!(out, a, dims = 2, rev=true)
        @test out == b_bd_2

        @testset "Boundary" begin
            # These originally lives in Images and we use it to check the compatibility
            forwarddiffy(u::AbstractMatrix) = [u[2:end,:]; u[end:end,:]] - u
            forwarddiffx(u::AbstractMatrix) = [u[:,2:end] u[:,end:end]] - u
            backdiffy(u::AbstractMatrix) = u - [u[1:1,:]; u[1:end-1,:]]
            backdiffx(u::AbstractMatrix) = u - [u[:,1:1] u[:,1:end-1]]

            X = rand(3, 3)
            @test forwarddiffx(X) == fdiff(X, dims=2, boundary=:zero)
            @test forwarddiffy(X) == fdiff(X, dims=1, boundary=:zero)
            @test backdiffx(X) == fdiff(X, dims=2, rev=true, boundary=:zero)
            @test backdiffy(X) == fdiff(X, dims=1, rev=true, boundary=:zero)
        end

        if VERSION >= v"1.1"
            # dims keyword for diff only exists after Julia 1.1
            # check numerical results with base implementation
            drop_last_slice(X, dims) = collect(StackView(collect(eachslice(X, dims=dims))[1:end-1]..., dims=dims))
            function drop_last_slice(X::AbstractVector, dims)
                @assert dims==1
                X[1:end-1]
            end
            drop_first_slice(X, dims) = collect(StackView(collect(eachslice(X, dims=dims))[2:end]..., dims=dims))
            function drop_first_slice(X::AbstractVector, dims)
                @assert dims==1
                X[2:end]
            end

            for N in 1:3
                sz = ntuple(_->5, N)
                A = rand(sz...)
                A_out = similar(A)

                for dims = 1:N
                    out_base = diff(A; dims=dims)
                    out = fdiff(A; dims=dims)
                    @test out_base == drop_last_slice(out, dims)

                    out_base = .-reverse(diff(reverse(A; dims=dims); dims=dims); dims=dims)
                    out = fdiff(A; dims=dims, rev=true)
                    @test out_base == drop_first_slice(out, dims)
                end
            end
        end
    end

    @testset "OffsetArrays" begin
        A = OffsetArray(rand(3, 3), -1, -1)
        A_out = fdiff(A, dims=1)
        @test axes(A_out) == (0:2, 0:2)
        @test A_out.parent == fdiff(parent(A), dims=1)

        A = OffsetArray(rand(3, 3), -1, -1)
        A_out = fdiff(A, dims=1, rev=true)
        @test axes(A_out) == (0:2, 0:2)
        @test A_out.parent == fdiff(parent(A), dims=1, rev=true)
    end

    @testset "FixedPoint" begin
        A = rand(N0f8, 6, 6)
        @test fdiff(A, dims=1) == fdiff(float.(A), dims=1)
    end
end

@testset "fgradient" begin
    for T in generate_test_types([N0f8, Float32], [Gray, RGB])
        for sz in [(7, ), (7, 5), (7, 5, 3)]
            A = rand(T, sz...)

            ∇A = fgradient(A)
            for i in 1:length(sz)
                @test ∇A[i] == fdiff(A, dims=i)
            end
            ∇A = fgradient(A; boundary=:zero)
            for i in 1:length(sz)
                @test ∇A[i] == fdiff(A, dims=i, boundary=:zero)
            end
            ∇A = map(similar, ∇A)
            @test fgradient!(∇A, A) == fgradient(A)
            @test fgradient!(∇A, A; boundary=:zero) == fgradient(A; boundary=:zero)

            ∇tA = fgradient(A, adjoint=true)
            for i in 1:length(sz)
                @test ∇tA[i] == .-fdiff(A, dims=i, rev=true)
            end
            ∇tA = fgradient(A, adjoint=true, boundary=:zero)
            for i in 1:length(sz)
                @test ∇tA[i] == .-fdiff(A, dims=i, rev=true, boundary=:zero)
            end
            ∇tA = map(similar, ∇tA)
            @test fgradient!(∇tA, A, adjoint=true) == fgradient(A, adjoint=true)
            @test fgradient!(∇tA, A, adjoint=true, boundary=:zero) == fgradient(A, adjoint=true, boundary=:zero)
        end
    end
end

@testset "fdiv/flaplacian" begin
    ref_laplacian(X) = imfilter(X, Kernel.Laplacian(ntuple(x->true, ndims(X))), "circular")

    X = [
        5  3  8  1  2  2  3
        5  5  1  3  3  1  1
        1  8  2  9  1  2  7
        7  3  4  5  8  1  5
        1  4  1  8  8  9  7
    ]
    ΔX_ref = [
        -8   10  -26   17    6    7    3
        -8   -3   14    2   -5    4   12
        23  -21   14  -25   18    2  -19
       -18   11   -5    9  -17   20    2
        19   -8   20  -17   -5  -18  -10
    ]
    ΔX = ref_laplacian(X)
    # Base.diff doesn't promote Int to floats so we should probably do the same for laplacian
    @test eltype(ΔX) == Int
    @test ΔX_ref == ΔX

    for T in generate_test_types([N0f8, Float32], [Gray, RGB])
        for sz in [(7,), (7, 7), (7, 7, 7)]
            A = rand(T, sz...)
            ∇A = fgradient(A)
            out = fdiv(∇A)
            @test out ≈ ref_laplacian(A)

            fill!(out, zero(T))
            fdiv!(out, ∇A...)
            @test out == fdiv(∇A)
        end
    end

    for T in generate_test_types([N0f8, Float32], [Gray, RGB])
        for sz in [(7,), (7, 7), (7, 7, 7)]
            A = rand(T, sz...)
            out = flaplacian(A)
            @test out ≈ ref_laplacian(A)

            ∇A = fgradient(A)
            foreach((out, ∇A...)) do x
                fill!(x, zero(T))
            end
            flaplacian!(out, ∇A, A)
            @test out == flaplacian(A)
            @test ∇A == fgradient(A)
        end
    end
end

macro warnpcfail(ex::Expr)
    modl = __module__
    file = __source__.file === nothing ? "?" : String(__source__.file)
    line = __source__.line
    quote
        $(esc(ex)) || @warn """precompile directive
     $($(Expr(:quote, ex)))
 failed. Please report an issue in $($modl) (after checking for duplicates) or remove this directive.""" _file=$file _line=$line
    end
end

function _precompile_()
    for ST in (N0f8, Float32, Float64)
        for T in (Gray{ST}, RGB{ST})
            @warnpcfail precompile(restrict, (Vector{T},))
            @warnpcfail precompile(restrict, (Matrix{T},))
        end
    end
end # _precompile_

"""
    IfElse(condition, f1, f2)

Create a function mapping `x -> condition(x) ? f1(x) : f2(x)`.

This is essentially the same as the anonymous function, but more
interpretable in stacktraces and more amenable to precompilation.
"""
struct IfElse{C,F1,F2}
    condition::C
    f1::F1
    f2::F2
end
(m::IfElse)(x) = m.condition(x) ? m.f1(x) : m.f2(x)

# channelwise min/max
minc(x, y) = min(x, y)
minc(x::Color, y::Color) = mapc(min, x, y)
maxc(x, y) = max(x, y)
maxc(x::Color, y::Color) = mapc(max, x, y)

for (f1, f2) in ((:minc, :min), (:maxc, :max))
    @eval function Base.reducedim_init(f, ::typeof($f1), A::AbstractArray, region)
        Base.reducedim_init(f, $f2, A, region)
    end
end

# Because there exists the `FiniteDiff.jl` package with quite different purposes,
# this module is not expected to be reexported.
module FiniteDiff

using ImageCore
using ImageCore.MappedArrays: of_eltype

"""
Although stored as an array, image can also be viewed as a function from discrete grid space
Zᴺ to continuous space R if it is gray image, to C if it is complex-valued image
(MRI rawdata), to Rᴺ if it is colorant image, etc.
This module provides the discrete
version of gradient-related operators by viewing image arrays as functions.

This module provides:

- forward/backward difference [`fdiff`](@ref) are the Images-flavor of `Base.diff`
- gradient operator [`fgradient`](@ref) and its adjoint via keyword `adjoint=true`.
- divergence operator [`fdiv`](@ref) computes the sum of discrete derivatives of vector
  fields.
- laplacian operator [`flaplacian`](@ref) is the divergence of the gradient fields.

Every function in this module has its in-place version.
"""
FiniteDiff

export
    fdiff, fdiff!,
    fdiv, fdiv!,
    fgradient, fgradient!,
    flaplacian, flaplacian!


"""
    fdiff(A::AbstractArray; dims::Int, rev=false, boundary=:periodic)

A one-dimension finite difference operator on array `A`. Unlike `Base.diff`, this function doesn't
shrink the array size.

Take vector as an example, it computes `(A[2]-A[1], A[3]-A[2], ..., A[1]-A[end])`.

# Keywords

- `rev::Bool`
  If `rev==true`, then it computes the backward difference
  `(A[end]-A[1], A[1]-A[2], ..., A[end-1]-A[end])`.
- `boundary`
  By default it computes periodically in the boundary, i.e., `:periodic`.
  In some cases, one can fill zero values with `boundary=:zero`.

# Examples

```jldoctest; setup=:(using ImageBase.FiniteDiff: fdiff)
julia> A = [2 4 8; 3 9 27; 4 16 64]
3×3 $(Matrix{Int}):
 2   4   8
 3   9  27
 4  16  64

julia> diff(A, dims=2) # this function exists in Base
3×2 $(Matrix{Int}):
  2   4
  6  18
 12  48

julia> fdiff(A, dims=2)
3×3 $(Matrix{Int}):
  2   4   -6
  6  18  -24
 12  48  -60

julia> fdiff(A, dims=2, rev=true) # reverse diff
3×3 $(Matrix{Int}):
  -6   2   4
 -24   6  18
 -60  12  48

julia> fdiff(A, dims=2, boundary=:zero) # fill boundary with zeros
3×3 $(Matrix{Int}):
  2   4  0
  6  18  0
 12  48  0
```

See also [`fdiff!`](@ref) for the in-place version.
"""
fdiff(A::AbstractArray; kwargs...) = fdiff!(similar(A, maybe_floattype(eltype(A))), A; kwargs...)

"""
    fdiff!(dst::AbstractArray, src::AbstractArray; dims::Int, rev=false, boundary=:periodic)

The in-place version of [`fdiff`](@ref)
"""
function fdiff!(dst::AbstractArray, src::AbstractArray;
        dims=_fdiff_default_dims(src),
        rev=false,
        boundary::Symbol=:periodic)
    isnothing(dims) && throw(UndefKeywordError(:dims))
    axes(dst) == axes(src) || throw(ArgumentError("axes of all input arrays should be equal. Instead they are $(axes(dst)) and $(axes(src))."))
    N = ndims(src)
    1 <= dims <= N || throw(ArgumentError("dimension $dims out of range (1:$N)"))

    src = of_eltype(maybe_floattype(eltype(dst)), src)
    r = axes(src)
    r0 = ntuple(i -> i == dims ? UnitRange(first(r[i]), last(r[i]) - 1) : UnitRange(r[i]), N)
    r1 = ntuple(i -> i == dims ? UnitRange(first(r[i])+1, last(r[i])) : UnitRange(r[i]), N)

    d0 = ntuple(i -> i == dims ? UnitRange(last(r[i]), last(r[i])) : UnitRange(r[i]), N)
    d1 = ntuple(i -> i == dims ? UnitRange(first(r[i]), first(r[i])) : UnitRange(r[i]), N)

    if rev
        dst[r1...] .= view(src, r1...) .- view(src, r0...)
        if boundary == :periodic
            dst[d1...] .= view(src, d1...) .- view(src, d0...)
        elseif boundary == :zero
            dst[d1...] .= zero(eltype(dst))
        else
            throw(ArgumentError("Wrong boundary condition $boundary"))
        end
    else
        dst[r0...] .= view(src, r1...) .- view(src, r0...)
        if boundary == :periodic
            dst[d0...] .= view(src, d1...) .- view(src, d0...)
        elseif boundary == :zero
            dst[d0...] .= zero(eltype(dst))
        else
            throw(ArgumentError("Wrong boundary condition $boundary"))
        end
    end

    return dst
end

_fdiff_default_dims(A) = nothing
_fdiff_default_dims(A::AbstractVector) = 1

maybe_floattype(::Type{T}) where T = T
maybe_floattype(::Type{T}) where T<:FixedPoint = floattype(T)
maybe_floattype(::Type{CT}) where CT<:Color = base_color_type(CT){maybe_floattype(eltype(CT))}


"""
    fdiv(Vs...)

Compute the divergence of vector fields `Vs`.

See also [`fdiv!`](@ref) for the in-place version.
"""
function fdiv(V₁::AbstractArray{T}, Vs::AbstractArray{T}...) where T
    fdiv!(similar(V₁, maybe_floattype(T)), V₁, Vs...)
end
fdiv(Vs::Tuple) = fdiv(Vs...)

"""
    fdiv!(out, Vs...)

The in-place version of divergence operator [`fdiv`](@ref).
"""
function fdiv!(out::AbstractArray, V₁::AbstractArray, Vs::AbstractArray...)
    # This is the optimized version of `sum(v->fgradient(v; ajoint=true), (V₁, Vs...))`
    # by removing unnecessary memory allocations.
    all(v->axes(v) == axes(out), (V₁, Vs...)) || throw(ArgumentError("All axes of vector fields Vs and X should be the same."))

    # TODO(johnnychen94): for better performance, we can eliminate this `tmp` allocation by fusing multiple `fdiff` in the inner loop.
    out .= fdiff(V₁; dims=1, rev=true, boundary=:periodic)
    tmp = similar(out)
    for i in 1:length(Vs)
        out .+= fdiff!(tmp, Vs[i]; dims=i+1, rev=true, boundary=:periodic)
    end
    return out
end
fdiv!(out::AbstractArray, Vs::Tuple) = fdiv!(out, Vs...)

"""
    flaplacian(X::AbstractArray)

The discrete laplacian operator, i.e., the divergence of the gradient fields of `X`.

See also [`flaplacian!`](@ref) for the in-place version.
"""
flaplacian(X::AbstractArray) = flaplacian!(similar(X, maybe_floattype(eltype(X))), X)

"""
    flaplacian!(out, X)
    flaplacian!(out, ∇X::Tuple, X)

The in-place version of the laplacian operator [`flaplacian`](@ref).

!!! tip Avoiding allocations
    The two-argument method will allocate memory to store the intermediate
    gradient fields `∇X`. If you call this repeatedly with images of consistent size and type,
    consider using the three-argument form with pre-allocated memory for `∇X`,
    which will eliminate allocation by this function.
"""
flaplacian!(out, X::AbstractArray) = fdiv!(out, fgradient(X))
flaplacian!(out, ∇X::Tuple, X::AbstractArray) = fdiv!(out, fgradient!(∇X, X))


"""
    fgradient(X::AbstractArray; adjoint=false, boundary=:periodic) -> (∂₁X, ∂₂X, ..., ∂ₙX)

Computes the gradient fields of `X`. If `adjoint==true` then it computes the adjoint gradient
fields.

Each gradient vector is computed as forward difference along specific dimension, e.g.,
[`∂ᵢX = fdiff(X, dims=i)`](@ref fdiff). The `boundary` keyword is passed to `fdiff` to
specify the behavior on boundary.

Mathematically, the adjoint operator ∂ᵢ' of ∂ᵢ is defined as `<∂ᵢu, v> := <u, ∂ᵢ'v>`, where
`<a, b>` is the inner product of vector `a` and `b`.

See also the in-place version [`fgradient!(X)`](@ref) to reuse the allocated memory.
"""
function fgradient(X::AbstractArray{T,N}; adjoint::Bool=false, boundary=:periodic) where {T,N}
    fgradient!(ntuple(i->similar(X, maybe_floattype(T)), N), X; adjoint=adjoint, boundary=boundary)
end

"""
    fgradient!(∇X::Tuple, X::AbstractArray; adjoint=false, boundary=:periodic)

The in-place version of (adjoint) gradient operator [`fgradient`](@ref).

The input `∇X = (∂₁X, ∂₂X, ..., ∂ₙX)` is a tuple of arrays that are similar to `X`, i.e.,
`eltype(∂ᵢX) == eltype(X)` and `axes(∂ᵢX)  == axes(X)` for all `i`.
"""
function fgradient!(∇X::NTuple{N, <:AbstractArray}, X; adjoint::Bool=false, boundary=:periodic) where N
    all(v->axes(v) == axes(X), ∇X) || throw(ArgumentError("All axes of vector fields ∇X and X should be the same."))
    for i in 1:N
        if adjoint
            # the negative adjoint of gradient operator for forward difference is the backward difference
            # see also
            # Getreuer, Pascal. "Rudin-Osher-Fatemi total variation denoising using split Bregman." _Image Processing On Line_ 2 (2012): 74-95.
            fdiff!(∇X[i], X, dims=i, rev=true, boundary=boundary)
            # TODO(johnnychen94): ideally we can get avoid flipping the signs for better performance.
            @. ∇X[i] = -∇X[i]
        else
            fdiff!(∇X[i], X, dims=i, boundary=boundary)
        end
    end
    return ∇X
end



if VERSION < v"1.1"
    isnothing(x) = x === nothing
end

end # module

# BEGIN 0.1 deprecation

@deprecate restrict(A::AbstractArray, region::Vector{Int}) restrict(A, (region...,))

@deprecate meanfinite(A::AbstractArray, region) meanfinite(A; dims=region)

@deprecate minfinite(A; kwargs...) minimum_finite(A; kwargs...)
@deprecate maxfinite(A; kwargs...) maximum_finite(A; kwargs...)
@deprecate maxabsfinite(A; kwargs...) maximum_finite(abs, A; kwargs...)

# These two symbols are exported by previous ImageBase versions and now organized in the
# FiniteDiff submodule.
@deprecate fdiff(args...; kwargs...) ImageBase.FiniteDiff.fdiff(args...; kwargs...)
@deprecate fdiff!(args...; kwargs...) ImageBase.FiniteDiff.fdiff!(args...; kwargs...)

# END 0.1 deprecation

using Documenter, ImageBase, ImageShow

format = Documenter.HTML(edit_link = "master",
                         prettyurls = get(ENV, "CI", nothing) == "true")

makedocs(modules  = [ImageBase, ],
         format   = format,
         sitename = "ImageBase",
         pages    = ["index.md", "reference.md"])

deploydocs(repo   = "github.com/JuliaImages/ImageBase.jl.git")

@testset "restrict" begin
    @testset "interfaces" begin
        A = rand(N0f8, 4, 5, 3)

        Ar = @inferred restrict(A, 1)
        @test typeof(Ar) <: Array
        @test size(Ar) == (3, 5, 3)

        Ar = @inferred restrict(A, (1, ))
        @test typeof(Ar) <: Array
        @test size(Ar) == (3, 5, 3)

        Ar = @inferred restrict(A, (1, 2, 3))
        @test typeof(Ar) <: Array
        @test size(Ar) == (3, 3, 2)
        @test Ar == restrict(A)

        @test_throws MethodError restrict(A, 1, 2, 3)
    end

    @testset "numerical test" begin
        A = reshape([UInt16(i) for i = 1:60], 4, 5, 3)
        B = restrict(A, (1,2))
        Btarget = cat([0.96875   4.625   5.96875;
                       2.875    10.5    12.875;
                       1.90625   5.875   6.90625],
                      [8.46875  14.625  13.46875;
                       17.875    30.5    27.875;
                       9.40625  15.875  14.40625],
                      [15.96875  24.625  20.96875;
                       32.875    50.5    42.875;
                       16.90625  25.875  21.90625], dims=3)
        @test B ≈ Btarget

        Argb = reinterpretc(RGB, reinterpret(N0f16, permutedims(A, (3,1,2))))
        B = restrict(Argb)
        Bf = permutedims(reinterpretc(eltype(eltype(B)), B), (2,3,1))
        # isapprox no longer lies, so atol is now serious
        @test isapprox(Bf, Btarget/reinterpret(one(N0f16)), atol=1e-10)

        Argba = reinterpretc(RGBA{N0f16}, reinterpret(N0f16, A))
        B = restrict(Argba)
        @test isapprox(reinterpretc(eltype(eltype(B)), B), restrict(A, (2,3))/reinterpret(one(N0f16)), atol=1e-10)

        A = reshape(1:60, 5, 4, 3)
        B = restrict(A, (1,2,3))
        @test cat([2.6015625   8.71875   6.1171875;
                   4.09375    12.875     8.78125;
                   3.5390625  10.59375   7.0546875],
                  [10.1015625  23.71875  13.6171875;
                   14.09375    32.875    18.78125;
                   11.0390625  25.59375  14.5546875], dims=3) ≈ B
    end

    @testset "singleton dimension" begin
        # https://github.com/JuliaImages/ImageTransformations.jl/issues/47
        @test restrict([1]) == [1.0]
        @test restrict([0 1 0]) == [0.25 0.25]
        @test restrict([0, 1, 0], 5) == [0, 1, 0]
    end
   
    @testset "OffsetArray" begin
        A = rand(5, 4, 3)
        Ao = OffsetArray(A, (-2,1,0))

        for (dims, offsets) in [
                (1,      (-1, 1, 0)),
                (2,      (-2, 0, 0)),
                ((1, 2), (-1, 0, 0))
            ]
            Ar = @inferred restrict(Ao, dims)
            @test typeof(Ar) <: OffsetArray
            @test Ar.offsets == offsets
            @test parent(Ar) == restrict(A, dims)
        end
    end

    @testset "SubArray" begin
        x0 = [0, 0, 1, 1, 0, 0]
        xv = @view x0[1:2:6]
        x = x0[1:2:6]
        xr = restrict(xv)
        @test xr == restrict(x)
        @test xr isa Array

        x = view(x0, IdentityUnitRange(3:5))
        xr = restrict(x)
        @test xr == restrict(collect(x))
        @test xr isa Array
    end

    @testset "FixedPoint overflow" begin
        # issue https://github.com/JuliaImages/Images.jl/issues/395
        img1 = colorview(RGB, fill(0.9, 3, 5, 5))
        img2 = colorview(RGB, fill(N0f8(0.9), 3, 5, 5))
        @test isapprox(channelview(restrict(img1)), channelview(restrict(img2)), rtol=0.01)
    end

    @testset "Array of arrays" begin
        a = Vector{Int}[[3,3,3], [2,1,7],[-11,4,2]]
        @test restrict(a) == Vector{Float64}[[2,3.5/2,6.5/2], [-5,4.5/2,5.5/2]]
    end

    @testset "various colorant" begin
        # issue https://github.com/JuliaImages/Images.jl/issues/652
        img = testimage("cameraman")
        @test eltype(@inferred(restrict(img))) == Gray{Float32}
        img = testimage("mandrill")
        @test eltype(@inferred(restrict(img))) == RGB{Float32}
        @test eltype(@inferred(restrict(Lab.(img)))) == RGB{Float32}
        img = rand(RGBA{N0f8}, 11, 11)
        @test eltype(@inferred(restrict(img))) == RGBA{Float32}
        @test eltype(@inferred(restrict(LabA.(img)))) == ARGB{Float32}

        ori = repeat(distinguishable_colors(10), inner=(1, 10))
        for T in (
            RGB, BGR, RGBX, XRGB,
            ARGB, RGBA,
            RGB24, ARGB32,
        )
            img = T.(ori)
            out = @inferred restrict(img)
            if T == RGB24
                @test eltype(out) == RGB{Float32}
            elseif T == ARGB32
                @test eltype(out) == ARGB{Float32}
            else
                @test eltype(out) <: T
            end
            ref = restrict(ori)
            @test ref ≈ RGB.(out)
        end
        for T in (Gray, AGray, GrayA, Gray24)
            img = T.(ori)
            out = @inferred restrict(img)
            if T == Gray24
                @test eltype(out) == Gray{Float32}
            else
                @test eltype(out) <: T
            end
            ref = restrict(Gray.(ori))
            @test ref ≈ Gray.(out)
        end
    end
end

"""
    minimum_finite([f=identity], A; kwargs...)

Calculate `minimum(f, A)` while ignoring any values that are not finite, e.g., `Inf` or
`NaN`.

If `A` is a colorant array with multiple channels (e.g., `Array{RGB}`), the `min` comparison
is done in channel-wise sense.

The supported `kwargs` are those of `minimum(f, A; kwargs...)`.
"""
function minimum_finite(f, A::AbstractArray{T}; kwargs...) where T
    # FIXME(johnnychen94): if `typeof(f(first(A))) != eltype(A)`, this function is not type-stable.
    mapreduce(IfElse(isfinite, f, typemax), minc, A; kwargs...)
end
minimum_finite(A::AbstractArray; kwargs...) = minimum_finite(identity, A; kwargs...)

"""
    maximum_finite([f=identity], A; kwargs...)

Calculate `maximum(f, A)` while ignoring any values that are not finite, e.g., `Inf` or
`NaN`.

If `A` is a colorant array with multiple channels (e.g., `Array{RGB}`), the `max` comparison
is done in channel-wise sense.

The supported `kwargs` are those of `maximum(f, A; kwargs...)`.
"""
function maximum_finite(f, A::AbstractArray{T}; kwargs...) where T
    # FIXME(johnnychen94): if `typeof(f(first(A))) != eltype(A)`, this function is not type-stable
    mapreduce(IfElse(isfinite, f, typemin), maxc, A; kwargs...)
end
maximum_finite(A::AbstractArray; kwargs...) = maximum_finite(identity, A; kwargs...)

"""
    sumfinite([f=identity], A; kwargs...)

Compute `sum(f, A)` while ignoring any non-finite values.

The supported `kwargs` are those of `sum(f, A; kwargs...)`.
"""
sumfinite(A; kwargs...) = sumfinite(identity, A; kwargs...)

if Base.VERSION >= v"1.1"
    sumfinite(f, A; kwargs...) = sum(IfElse(isfinite, f, zero), A; kwargs...)
else
    sumfinite(f, A; kwargs...) = sum(IfElse(isfinite, f, zero).(A); kwargs...)
end

"""
    meanfinite([f=identity], A; kwargs...)

Compute `mean(f, A)` while ignoring any non-finite values.

The supported `kwargs` are those of `sum(f, A; kwargs...)`.
"""
meanfinite(A; kwargs...) = meanfinite(identity, A; kwargs...)

if Base.VERSION >= v"1.1"
    function meanfinite(f, A; kwargs...)
        s = sumfinite(f, A; kwargs...)
        n = sum(IfElse(isfinite, x->true, x->false), A; kwargs...)   # TODO: replace with `Returns`
        return s./n
    end
else
    function meanfinite(f, A; kwargs...)
        s = sumfinite(f, A; kwargs...)
        n = sum(IfElse(isfinite, x->true, x->false).(A); kwargs...)
        return s./n
    end
end

"""
    varfinite(A; kwargs...)

Compute the variance of `A`, ignoring any non-finite values.

The supported `kwargs` are those of `sum(f, A; kwargs...)`.

!!! note
    This function can produce a seemingly suprising result if the input array is an RGB
    image. To make it more clear, the implementation is made so that
    `varfinite(img) ≈ varfinite(RGB.(img))` holds for any gray-scale image. See also
    https://github.com/JuliaGraphics/ColorVectorSpace.jl#abs-and-abs2 for more information.

"""
function varfinite end

if Base.VERSION >= v"1.1"
    function varfinite(A; kwargs...)
        m = meanfinite(A; kwargs...)
        n = sum(IfElse(isfinite, x->true, x->false), A; kwargs...)   # TODO: replace with `Returns`
        s = sum(IfElse(isfinite, identity, zero), abs2.(A .- m); kwargs...)
        return s ./ max.(0, (n .- 1))
    end
else
    function varfinite(A; kwargs...)
        m = meanfinite(A; kwargs...)
        n = sum(IfElse(isfinite, x->true, x->false).(A); kwargs...)
        s = sum(IfElse(isfinite, identity, zero).(abs2.(A .- m)); kwargs...)
        return s ./ max.(0, (n .- 1))
    end
end

# ImageBase


This is a twin package to [ImageCore](https://github.com/JuliaImages/ImageCore.jl) with functions that are used among many of the packages in JuliaImages.
The main purpose of this package is to reduce unnecessary compilation overhead from external dependencies.

This package reexports [ImageCore](https://github.com/JuliaImages/ImageCore.jl) so can be a direct replacement of it.

Check the [reference page](@ref function_reference) for more information.

# [Reference](@id function_reference)

## Spatial transformation

- `restrict` originally lives in [ImageTransformation.jl](https://github.com/JuliaImages/ImageTransformations.jl). This function is still reexported by ImageTransformation.

```@docs
restrict
```

## Discrete gradient operator

```@autodocs
Modules = [ImageBase.FiniteDiff]
order = [:module, :function]
```

## Statistics

```@docs
minimum_finite
maximum_finite
meanfinite
varfinite
sumfinite
```
